#include <Wire.h>
#include <LiquidCrystal_I2C.h>
#include <Stepper.h>
#include <Servo.h>
//variables for servo
Servo servo;
// Define the servo pin:
#define servoPin 3
int servo_angle = 45;
//variables for stepper
//2048 steps for 1 rotation of the small wheel
int step_total = 14500;
int stepper_turn = 2048;
int stepper_photo;
int step_rate = 10;
Stepper myStepper = Stepper(stepper_turn, 8, 10, 9, 11);
//variables for LCD display
int lcd_screen = 3;
int Press_through_time = 500;
int wait_time = 3000;
//variables for joystick
int VRx = A1;
int VRy = A0;
int button = 2;
int xPosition = 0;
int yPosition = 0;
int mapX = 0;
int mapY = 0;
int xposition = 0;
int yposition = 0;
int jsButton = 0;
int minimum_photos = 12;
int maximum_photos = 48;
int photocounter = minimum_photos + (maximum_photos - minimum_photos)/2;
String number_of_photos;
String numberphototext1 = "- <-- ";
String numberphototext2 = " --> +";
int photo_selector_menu = 0;
//variables for scanning
int scan_menu;
int photo_take_time = 3000;
//rotate variables
int rotate_menu;
LiquidCrystal_I2C lcd(0x27, 2, 1, 0, 4, 5, 6, 7, 3, POSITIVE);
void setup() {
Serial.begin(9600);
digitalWrite(5, HIGH);
digitalWrite(6, HIGH);
digitalWrite(7, LOW);
//servo setup
servo.attach(servoPin);
servo.write(servo_angle);
//stepper setup
myStepper.setSpeed(step_rate);
//setup lcd screen
pinMode(lcd_screen, OUTPUT);
lcd.begin(16,2);
choicemenu();
//setup joystick
pinMode(VRx, INPUT);
pinMode(VRy, INPUT);
pinMode(button, INPUT_PULLUP);
}
void loop() {
//Read the joystick values and convert them to a selection left, right or center
xposition = X_joystickupdate(VRx, mapX);
yposition = Y_joystickupdate(VRy, mapY);
jsButton = js_button_joystickupdate(button);
//start scan code
if(yposition == 1){
lcd.clear();
lcd.setCursor(0, 0);
lcd.print("3D scan: Press");
lcd.setCursor(0, 1);
lcd.print("<- Back");
while((jsButton == 1) && (yposition != -1)){
xposition = X_joystickupdate(VRx, mapX);
yposition = Y_joystickupdate(VRy, mapY);
jsButton = js_button_joystickupdate(button);
if(yposition == -1){
choicemenu();
delay(Press_through_time);
}
if((jsButton == 0) && (yposition != -1)){
photo_selector_menu = 1;
//update LCD screen to show the number_of_photos
number_of_photos = numberphototext1 + photocounter + numberphototext2;
lcd.clear();
lcd.setCursor(0, 0);
lcd.print("number_of_photos:");
lcd.setCursor(0, 1);
lcd.print(number_of_photos);
delay(Press_through_time);
}
}
while(photo_selector_menu == 1){
//update the joystick selection again depending on how the user uses the joystick
xposition = X_joystickupdate(VRx, mapX);
yposition = Y_joystickupdate(VRy, mapY);
jsButton = js_button_joystickupdate(button);
if((jsButton == 0) && (xposition == 0) && (yposition == 0)) {
scan_menu = 1;
delay(Press_through_time);
}
while(scan_menu == 1){
//here should be the code that causes the platform to run ... distance every time
//to scan the object
stepper_photo = step_total / photocounter;
for(int i = 1; i <= photocounter; i++){
if(i == photocounter){
scan_menu = 0;
photo_selector_menu = 0;
}
int scan_percentage = ((100 * (i-1))/photocounter);
Serial.println(scan_percentage);
int place_ratio_percentage= 0;
int placemark_ratio = 0;
if(i >= 10){ placemark_ratio = 1;}
if(scan_percentage >= 10){place_ratio_percentage= 1;}
if(scan_percentage >= 100){ place_ratio_percentage= 2;}
//lcd text
lcd.clear();
lcd.setCursor(0, 0);
lcd.print("Scan...");
lcd.setCursor(0, 1);
lcd.print(i - 1);
lcd.setCursor((1 + placemark_ratio), 1);
lcd.print("/");
lcd.setCursor((2 + placemark_ratio), 1);
lcd.print(photocounter);
lcd.setCursor((7), 1);
lcd.print(scan_percentage);
lcd.setCursor((9 + place_ratio_percentage), 1);
lcd.print("%");
myStepper.step(stepper_photo);
//here the code where the servo Presss on the button to make a
//take a photo, if this is in the delay can be removed
servo.write(servo_angle - 25);
delay(100);
servo.write(servo_angle);
delay(photo_take_time);
Serial.println("scanned");
}
lcd.clear();
// put menu text on screen
lcd.setCursor(0, 0);
lcd.print("Scan Completed");
delay(wait_time);
choicemenu();
};
Serial.println("done scanning");
//when the photo counter is at the minimum or maximum number_of_photos,
//will the user selected action of minus, respectively, plus
//photos are converted to 0, so the photo counter is not smaller or larger
//can be then the minimum or maximum counter
if((photocounter == minimum_photos)&&(yposition == -1)){
yposition = 0;
}
if((photocounter == maximum_photos)&&(yposition == 1)){
yposition = 0;
}
if(yposition != 0){
photocounter = photocounter + yposition;
number_of_photos = numberphototext1 + photocounter + numberphototext2;
lcd.clear();
lcd.setCursor(0, 0);
lcd.print("number_of_photos:");
lcd.setCursor(0, 1);
lcd.print(number_of_photos);
}
};
Serial.println("from the photo selection menu");
}
//end scan code
xposition = X_joystickupdate(VRx, mapX);
yposition = Y_joystickupdate(VRy, mapY);
jsButton = js_button_joystickupdate(button);
//start spin code
if(yposition == -1){
lcd.clear();
lcd.setCursor(0, 0);
lcd.print("Rotate: Press");
lcd.setCursor(0, 1);
lcd.print("Back ->");
while((jsButton == 1) && (yposition != 1)){
xposition = X_joystickupdate(VRx, mapX);
yposition = Y_joystickupdate(VRy, mapY);
jsButton = js_button_joystickupdate(button);
if(yposition == 1){
choicemenu();
delay(Press_through_time);
}
if((jsButton == 0) && (yposition != 1)){
rotate_menu = 1;
//update LCD screen to show the number_of_photos
number_of_photos = numberphototext1 + photocounter + numberphototext2;
lcd.clear();
lcd.setCursor(0, 0);
lcd.print("Free run: Up");
lcd.setCursor(0, 1);
lcd.print("Run: Down");
}
}
while(rotate_menu == 1){
xposition = X_joystickupdate(VRx, mapX);
yposition = Y_joystickupdate(VRy, mapY);
jsButton = js_button_joystickupdate(button);
if(xposition == 1){
Serial.print("Up");
rotate_menu = 2;
delay(Press_through_time);
lcd.clear();
lcd.setCursor(0, 0);
lcd.print("<-rotate->");
lcd.setCursor(0, 1);
lcd.print("Back: Press");
}
if(xposition == -1){
Serial.print("down");
rotate_menu = 3;
delay(Press_through_time);
}
while(rotate_menu == 2){
xposition = X_joystickupdate(VRx, mapX);
yposition = Y_joystickupdate(VRy, mapY);
jsButton = js_button_joystickupdate(button);
if(jsButton == 0){
rotate_menu = 0;
choicemenu();
}
while(yposition == -1){
yposition = Y_joystickupdate(VRy, mapY);
myStepper.step(-100);
}
while(yposition == 1){
yposition = Y_joystickupdate(VRy, mapY);
myStepper.step(100);
}
//code with while loops allowing it to rotate left and right
}
while(rotate_menu == 3){
for(int i = 0; i <= 100; i++){
int place_ratio_percent = 1;
if(i >= 10){place_ratio_percent = 2;}
if(i >= 100){place_ratio_percent = 3;}
int step_percent = step_total/100;
lcd.clear();
lcd.setCursor(0, 0);
lcd.print("Run:");
lcd.setCursor(0, 1);
lcd.print(i);
lcd.setCursor((0 + place_ratio_percent),1);
lcd.print("%");
myStepper.step(step_percent);
}
lcd.clear();
lcd.setCursor(0, 0);
lcd.print("Done with");
lcd.setCursor(0, 1);
lcd.print("running:");
delay(wait_time);
choicemenu();
rotate_menu = 0;
}
};
}
//end spin code
}
int X_joystickupdate(int VRx, int mapX){ //in this function the position of the joystick is determined
int xPosition = analogRead(VRx);
int xposition;
mapX = map(xPosition, 0, 1023, -512, 512);
Serial.print("X place: ");
Serial.println(mapX);
if(mapX <= -256){xposition = 1;
Serial.print("x less than -256, ");};
if(mapX >= 256){xposition = -1;
Serial.print("x greater than 256, ");};
if((mapX > -256) && (mapX < 256)){xposition = 0;
Serial.print("x is in between, ");};
Serial.print("Xposition made: ");
Serial.println(xposition);
return xposition;
}
int Y_joystickupdate(int VRy, int mapY){ //in this function the position of the joystick is determined
int yPosition = analogRead(VRy);
int yposition;
mapY = map(yPosition, 0, 1023, -512, 512);
Serial.print("Y place: ");
Serial.println(mapY);
if(mapY <= -256){yposition = 1;
Serial.print("y less than -256, ");};
if(mapY >= 256){yposition = -1;
Serial.print("y greater than 256, ");};
if((mapY > -256) && (mapY < 256)){yposition = 0;
Serial.print("y is in between, ");};
Serial.print("Yposition made: ");
Serial.println(yposition);
return yposition;
}
int js_button_joystickupdate(int button){ //in this function the position of the joystick is determined
int jsButton = digitalRead(button);
Serial.print("joystick button: ");
Serial.println(jsButton);
return jsButton;
}
void choicemenu(){
lcd.clear();
// put menu text on screen
lcd.setCursor(0, 0);
lcd.print("Select Program: ");
lcd.setCursor(0, 1);
lcd.print("<-rotate||scan->");
}
